﻿using C1.Win.C1Document;
using C1.Win.C1Ribbon;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Printing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace prj_FlexReport_Printing
{
    public partial class PrintDemo : Form
    {
        PrintDialog dialog;
        public PrintDemo()
        {
            InitializeComponent();
            dialog = new PrintDialog();
        }

        private void PrintDemo_Load(object sender, EventArgs e)
        {
            c1FlexReport1.Load("../../Invoice.flxr", "Invoice");
            c1FlexViewer1.RibbonElements.Print.Visible = false;  
            RibbonButton btnPrintDialog = new RibbonButton();
            btnPrintDialog.Text = "Print";
            btnPrintDialog.LargeImage = c1FlexViewer1.RibbonElements.Print.LargeImage;
            btnPrintDialog.Click += BtnPrintDialog_Click;  
            c1FlexViewer1.Ribbon.Tabs[0].Groups[4].Items.Add(btnPrintDialog);
            c1FlexViewer1.DocumentSource = c1FlexReport1;

            c1FlexViewer2.RibbonElements.Print.Visible = false;
            RibbonButton btnPrintDirect = new RibbonButton();
            btnPrintDirect.Text = "Print";
            btnPrintDirect.LargeImage = c1FlexViewer1.RibbonElements.Print.LargeImage;
            btnPrintDirect.Click += BtnPrintDirect_Click;
            c1FlexViewer2.Ribbon.Tabs[0].Groups[4].Items.Add(btnPrintDirect);
            c1FlexViewer2.DocumentSource = c1FlexReport1;
        }   
        private void BtnPrintDialog_Click(object sender, EventArgs e)
        {
            dialog.AllowSelection = true;
            dialog.AllowSomePages = true;
            string printer = "Canon_GF";
            PrinterSettings options = new PrinterSettings();

            //setting PrinterName
            options.PrinterName = printer;

            //setting No. of Copies
            options.Copies = 2;

            //setting Print Range
            options.PrintRange = PrintRange.SomePages;
            options.FromPage = 5;
            options.ToPage = 6;

            dialog.PrinterSettings = options;

            //setting PaperSource
            PaperSource source = new PaperSource();
            source.SourceName = dialog.PrinterSettings.PaperSources[0].ToString();
            options.DefaultPageSettings.PaperSource = source;

            //setting PaperSize
            for (int i = 0; i <= options.PaperSizes.Count - 1; i++)
            {
                if ((options.PaperSizes[i].Kind == PaperKind.A3))
                {
                    options.DefaultPageSettings.PaperSize = options.PaperSizes[i];
                }
            }
            if (dialog.ShowDialog() == DialogResult.OK)
                c1FlexReport1.Print(options);
        }
        private void BtnPrintDirect_Click(object sender, EventArgs e)
        {

            string printer = "Canon_GF";
            C1PrintOptions options = new C1PrintOptions();
            options.PrinterSettings = new PrinterSettings();
            options.PageSettings = new PageSettings();

            //setting PrinterName
            options.PrinterSettings.PrinterName = printer;

            //setting No. of Copies
            options.PrinterSettings.Copies = 2;

            //setting Print Range
            options.PrinterSettings.PrintRange = PrintRange.SomePages;
            options.PrinterSettings.FromPage = 1;
            options.PrinterSettings.ToPage = 2;

            //setting PaperSource
            PaperSource source = new PaperSource();
            source.SourceName = "SourceName";
            options.PrinterSettings.DefaultPageSettings.PaperSource = source;

            //setting PaperSize
            for (int i = 0; i <= options.PrinterSettings.PaperSizes.Count - 1; i++)
            {
                if ((options.PrinterSettings.PaperSizes[i].Kind == PaperKind.A3))
                {
                    options.PageSettings.PaperSize = options.PrinterSettings.PaperSizes[i];
                }
            }
            c1FlexReport1.Print(options);
        }
    }
}
